    - name: Update /etc/containerd/config.toml mirror
      become: yes
      register: containerd_edit_1
      vars:
        tmp: "        [plugins.\"io.containerd.grpc.v1.cri\".registry.mirrors.\"{{ hostvars['controller']['ansible_default_ipv4']['address'] }}:5000\"]"
      ansible.builtin.lineinfile:
        path: /etc/containerd/config.toml
        search_string: "{{ tmp }}"
        insertafter: '^\s*\[plugins\."io.containerd.grpc.v1.cri"\.registry.mirrors\]'
        line: "{{ tmp }}"
    - name: Update /etc/containerd/config.toml mirror
      become: yes
      register: containerd_edit_2
      vars:
        tmp: "          endpoint = [\"http://{{ hostvars['controller']['ansible_default_ipv4']['address'] }}:5000\"]"
        tmpval: "[plugins.\"io.containerd.grpc.v1.cri\".registry.mirrors.\"{{ hostvars['controller']['ansible_default_ipv4']['address'] }}:5000\"]"
      ansible.builtin.lineinfile:
        path: /etc/containerd/config.toml
        search_string: "{{ tmp }}"
        insertafter: "^\\s*{{ tmpval | regex_escape() }}"
        line: "{{ tmp }}"

    - name: Update /etc/containerd/config.toml config
      become: yes
      register: containerd_edit_3
      vars:
        tmp: "        [plugins.\"io.containerd.grpc.v1.cri\".registry.configs.\"{{ hostvars['controller']['ansible_default_ipv4']['address'] }}:5000.tls\"]"
      ansible.builtin.lineinfile:
        path: /etc/containerd/config.toml
        search_string: "{{ tmp }}"
        insertafter: '^\s*\[plugins\."io.containerd.grpc.v1.cri"\.registry.configs\]'
        line: "{{ tmp }}"
    - name: Update /etc/containerd/config.toml config
      become: yes
      register: containerd_edit_4
      vars:
        tmp: "          insecure_skip_verify = true"
        tmpval: "[plugins.\"io.containerd.grpc.v1.cri\".registry.configs.\"{{ hostvars['controller']['ansible_default_ipv4']['address'] }}:5000.tls\"]"
      ansible.builtin.lineinfile:
        path: /etc/containerd/config.toml
        search_string: "{{ tmp }}"
        insertafter: "^\\s*{{ tmpval | regex_escape() }}"
        line: "{{ tmp }}"
    - name: Restart containerd
      become: yes
      shell:
        cmd: systemctl restart containerd
      when: containerd_edit_1 is changed or
            containerd_edit_2 is changed or
            containerd_edit_3 is changed or
            containerd_edit_4 is changed

    # Update docker to allow insecure connections
    - name: Get current value of /etc/docker/daemon.json
      slurp:
        src: /etc/docker/daemon.json
      register: imported_var
    - name: Add insecure entries setting to JSON
      vars:
        line: "{ 'insecure-registries' : ['{{ hostvars['controller']['ansible_default_ipv4']['address'] }}:5000'] }"
      set_fact:
        imported_var: "{{ imported_var.content|b64decode|from_json | default([]) | combine( line ) }}"
    - name: Write /etc/docker/daemon.json
      become: yes
      register: docker_edit
      copy:
        content: "{{ imported_var | to_nice_json }}"
        dest: /etc/docker/daemon.json
    - name: Restart docker
      become: yes
      command:
        cmd: systemctl restart docker
      when: docker_edit is changed
